# -*- coding: utf-8 -*-
# ------------------------------------------------------------------
#                 Device Type Defines.
# ------------------------------------------------------------------

DEVTYPE_EZI_SERVO2_PLUS_E_ST_86 = 101
DEVNAME_EZI_SERVO2_PLUS_E_ST_86 = "Ezi-SERVO II Plus-E-ST-86"

# ------------------------------------------------------------------
#                 Axis Status Flag Defines.
# ------------------------------------------------------------------


class EZISERVO2_86_AXISSTATUS:
    FFLAG_ERRORALL = 0x00000001
    FFLAG_HWPOSILMT = 0x00000002
    FFLAG_HWNEGALMT = 0x00000004
    FFLAG_SWPOGILMT = 0x00000008
    FFLAG_SWNEGALMT = 0x00000010
    FFLAG_RESERVED0 = 0x00000020
    FFLAG_RESERVED1 = 0x00000040
    FFLAG_ERRPOSOVERFLOW = 0x00000080
    FFLAG_ERROVERCURRENT = 0x00000100
    FFLAG_ERROVERSPEED = 0x00000200
    FFLAG_ERRPOSTRACKING = 0x00000400
    FFLAG_ERROVERLOAD = 0x00000800
    FFLAG_ERROVERHEAT = 0x00001000
    FFLAG_ERRBACKEMF = 0x00002000
    FFLAG_ERRMOTORPOWER = 0x00004000
    FFLAG_ERRINPOSITION = 0x00008000
    FFLAG_EMGSTOP = 0x00010000
    FFLAG_SLOWSTOP = 0x00020000
    FFLAG_ORIGINRETURNING = 0x00040000
    FFLAG_INPOSITION = 0x00080000
    FFLAG_SERVOON = 0x00100000
    FFLAG_ALARMRESET = 0x00200000
    FFLAG_PTSTOPPED = 0x00400000
    FFLAG_ORIGINSENSOR = 0x00800000
    FFLAG_ZPULSE = 0x01000000
    FFLAG_ORIGINRETOK = 0x02000000
    FFLAG_MOTIONDIR = 0x04000000
    FFLAG_MOTIONING = 0x08000000
    FFLAG_MOTIONPAUSE = 0x10000000
    FFLAG_MOTIONACCEL = 0x20000000
    FFLAG_MOTIONDECEL = 0x40000000
    FFLAG_MOTIONCONST = 0x80000000


# ------------------------------------------------------------------
#                 Input/Output Defines.
# ------------------------------------------------------------------

# Input Bit-mask list
SERVO2_86_IN_BITMASK_LIMITP = 0x00000001
SERVO2_86_IN_BITMASK_LIMITN = 0x00000002
SERVO2_86_IN_BITMASK_ORIGIN = 0x00000004
SERVO2_86_IN_BITMASK_CLEARPOSITION = 0x00000008
SERVO2_86_IN_BITMASK_PTA0 = 0x00000010
SERVO2_86_IN_BITMASK_PTA1 = 0x00000020
SERVO2_86_IN_BITMASK_PTA2 = 0x00000040
SERVO2_86_IN_BITMASK_PTA3 = 0x00000080
SERVO2_86_IN_BITMASK_PTA4 = 0x00000100
SERVO2_86_IN_BITMASK_PTA5 = 0x00000200
SERVO2_86_IN_BITMASK_PTA6 = 0x00000400
SERVO2_86_IN_BITMASK_PTA7 = 0x00000800
SERVO2_86_IN_BITMASK_PTSTART = 0x00001000
SERVO2_86_IN_BITMASK_STOP = 0x00002000
SERVO2_86_IN_BITMASK_PJOG = 0x00004000
SERVO2_86_IN_BITMASK_NJOG = 0x00008000
SERVO2_86_IN_BITMASK_ALARMRESET = 0x00010000
SERVO2_86_IN_BITMASK_SERVOON = 0x00020000
SERVO2_86_IN_BITMASK_PAUSE = 0x00040000
SERVO2_86_IN_BITMASK_ORIGINSEARCH = 0x00080000
SERVO2_86_IN_BITMASK_TEACHING = 0x00100000
SERVO2_86_IN_BITMASK_ESTOP = 0x00200000
SERVO2_86_IN_BITMASK_JPTIN0 = 0x00400000
SERVO2_86_IN_BITMASK_JPTIN1 = 0x00800000
SERVO2_86_IN_BITMASK_JPTIN2 = 0x01000000
SERVO2_86_IN_BITMASK_JPTSTART = 0x02000000
SERVO2_86_IN_BITMASK_USERIN0 = 0x04000000
SERVO2_86_IN_BITMASK_USERIN1 = 0x08000000
SERVO2_86_IN_BITMASK_USERIN2 = 0x10000000
SERVO2_86_IN_BITMASK_USERIN3 = 0x20000000
SERVO2_86_IN_BITMASK_USERIN4 = 0x40000000
SERVO2_86_IN_BITMASK_USERIN5 = 0x80000000
SERVO2_86_IN_BITMASK_USERIN6 = 0x00000200
SERVO2_86_IN_BITMASK_USERIN7 = 0x00000400
SERVO2_86_IN_BITMASK_USERIN8 = 0x00000800

# Output Bit-mask list
SERVO2_86_OUT_BITMASK_COMPAREOUT = 0x00000001
SERVO2_86_OUT_BITMASK_INPOSITION = 0x00000002
SERVO2_86_OUT_BITMASK_ALARM = 0x00000004
SERVO2_86_OUT_BITMASK_MOVING = 0x00000008
SERVO2_86_OUT_BITMASK_ACCDEC = 0x00000010
SERVO2_86_OUT_BITMASK_ACK = 0x00000020
SERVO2_86_OUT_BITMASK_END = 0x00000040
SERVO2_86_OUT_BITMASK_PUSHDETECT = 0x00000080
SERVO2_86_OUT_BITMASK_ORGSEARCHOK = 0x00000100
SERVO2_86_OUT_BITMASK_SERVOREADY = 0x00000200
# SERVO2_86_OUT_BITMASK_RESERVED     = 0x00000400
# SERVO2_86_OUT_BITMASK_RESERVED     = 0x00000800
SERVO2_86_OUT_BITMASK_PTOUT0 = 0x00001000
SERVO2_86_OUT_BITMASK_PTOUT1 = 0x00002000
SERVO2_86_OUT_BITMASK_PTOUT2 = 0x00004000
SERVO2_86_OUT_BITMASK_USEROUT0 = 0x00008000
SERVO2_86_OUT_BITMASK_USEROUT1 = 0x00010000
SERVO2_86_OUT_BITMASK_USEROUT2 = 0x00020000
SERVO2_86_OUT_BITMASK_USEROUT3 = 0x00040000
SERVO2_86_OUT_BITMASK_USEROUT4 = 0x00080000
SERVO2_86_OUT_BITMASK_USEROUT5 = 0x00100000
SERVO2_86_OUT_BITMASK_USEROUT6 = 0x00200000
SERVO2_86_OUT_BITMASK_USEROUT7 = 0x00400000
SERVO2_86_OUT_BITMASK_USEROUT8 = 0x00800000


# ------------------------------------------------------------------
#                 Input/Output Assigning Defines.
# ------------------------------------------------------------------

SERVO2_86_IN_PREASSIGN_LIMITP = 1
SERVO2_86_IN_PREASSIGN_LIMITN = 2
SERVO2_86_IN_PREASSIGN_ORIGIN = 3

SERVO2_86_IN_LOGIC_CLEARPOSITION = 4
SERVO2_86_IN_LOGIC_PTA0 = 5
SERVO2_86_IN_LOGIC_PTA1 = 6
SERVO2_86_IN_LOGIC_PTA2 = 7
SERVO2_86_IN_LOGIC_PTA3 = 8
SERVO2_86_IN_LOGIC_PTA4 = 9
SERVO2_86_IN_LOGIC_PTA5 = 10
SERVO2_86_IN_LOGIC_PTA6 = 11
SERVO2_86_IN_LOGIC_PTA7 = 12
SERVO2_86_IN_LOGIC_PTSTART = 13
SERVO2_86_IN_LOGIC_STOP = 14
SERVO2_86_IN_LOGIC_PJOG = 15
SERVO2_86_IN_LOGIC_NJOG = 16
SERVO2_86_IN_LOGIC_ALARMRESET = 17
SERVO2_86_IN_LOGIC_SERVOON = 18
SERVO2_86_IN_LOGIC_PAUSE = 19
SERVO2_86_IN_LOGIC_ORIGINSEARCH = 20
SERVO2_86_IN_LOGIC_TEACHING = 21
SERVO2_86_IN_LOGIC_ESTOP = 22
SERVO2_86_IN_LOGIC_JPTIN0 = 23
SERVO2_86_IN_LOGIC_JPTIN1 = 24
SERVO2_86_IN_LOGIC_JPTIN2 = 25
SERVO2_86_IN_LOGIC_JPTSTART = 26
SERVO2_86_IN_LOGIC_USERIN0 = 27
SERVO2_86_IN_LOGIC_USERIN1 = 28
SERVO2_86_IN_LOGIC_USERIN2 = 29
SERVO2_86_IN_LOGIC_USERIN3 = 30
SERVO2_86_IN_LOGIC_USERIN4 = 31
SERVO2_86_IN_LOGIC_USERIN5 = 32

MAX_SERVO2_86_IN_LOGIC = 33


SERVO2_86_OUT_PREASSIGN_COMP = 1

SERVO2_86_OUT_LOGIC_INPOSITION = 2
SERVO2_86_OUT_LOGIC_ALARM = 3
SERVO2_86_OUT_LOGIC_MOVING = 4
SERVO2_86_OUT_LOGIC_ACCDEC = 5
SERVO2_86_OUT_LOGIC_ACK = 6
SERVO2_86_OUT_LOGIC_END = 7
SERVO2_86_OUT_LOGIC_PUSHDETECT = 8
SERVO2_86_OUT_LOGIC_ORGSEARCHOK = 9
SERVO2_86_OUT_LOGIC_SERVOREADY = 10
SERVO2_86_OUT_LOGIC_RESERVED1 = 11
SERVO2_86_OUT_LOGIC_RESERVED2 = 12
SERVO2_86_OUT_LOGIC_PTOUT0 = 13
SERVO2_86_OUT_LOGIC_PTOUT1 = 14
SERVO2_86_OUT_LOGIC_PTOUT2 = 15
SERVO2_86_OUT_LOGIC_USEROUT0 = 16
SERVO2_86_OUT_LOGIC_USEROUT1 = 17
SERVO2_86_OUT_LOGIC_USEROUT2 = 18
SERVO2_86_OUT_LOGIC_USEROUT3 = 19
SERVO2_86_OUT_LOGIC_USEROUT4 = 20
SERVO2_86_OUT_LOGIC_USEROUT5 = 21
SERVO2_86_OUT_LOGIC_USEROUT6 = 22
SERVO2_86_OUT_LOGIC_USEROUT7 = 23
SERVO2_86_OUT_LOGIC_USEROUT8 = 24

MAX_SERVO2_86_OUT_LOGIC = 25


SERVO2_86_IN_PIN_CNT = 12
SERVO2_86_OUT_PIN_CNT = 10

SERVO2_86_IN_LOGIC_CNT = MAX_SERVO2_86_IN_LOGIC - 1
SERVO2_86_MAX_PREASSIGNED_IN = SERVO2_86_IN_PREASSIGN_ORIGIN

SERVO2_86_OUT_LOGIC_CNT = MAX_SERVO2_86_OUT_LOGIC - 1
SERVO2_86_MAX_PREASSIGNED_OUT = SERVO2_86_OUT_PREASSIGN_COMP

# ------------------------------------------------------------------
#                 Parameters Defines.
# ------------------------------------------------------------------

SERVO2_86_PULSEPERREVOLUTION = 0
SERVO2_86_AXISMAXSPEED = 1
SERVO2_86_AXISSTARTSPEED = 2
SERVO2_86_AXISACCTIME = 3
SERVO2_86_AXISDECTIME = 4

SERVO2_86_SPEEDOVERRIDE = 5
SERVO2_86_JOGHIGHSPEED = 6
SERVO2_86_JOGLOWSPEED = 7
SERVO2_86_JOGACCDECTIME = 8

SERVO2_86_SWLMTPLUSVALUE = 9
SERVO2_86_SWLMTMINUSVALUE = 10
SERVO2_86_SOFTLMTSTOPMETHOD = 11
SERVO2_86_HARDLMTSTOPMETHOD = 12
SERVO2_86_LIMITSENSORLOGIC = 13

SERVO2_86_ORGSPEED = 14
SERVO2_86_ORGSEARCHSPEED = 15
SERVO2_86_ORGACCDECTIME = 16
SERVO2_86_ORGMETHOD = 17
SERVO2_86_ORGDIR = 18
SERVO2_86_ORGOFFSET = 19
SERVO2_86_ORGPOSITIONSET = 20
SERVO2_86_ORGSENSORLOGIC = 21

SERVO2_86_POSITIONLOOPGAIN = 22
SERVO2_86_INPOSITIONVALUE = 23
SERVO2_86_POSTRACKINGLIMIT = 24
SERVO2_86_MOTIONDIR = 25

SERVO2_86_LIMITSENSORDIR = 26
SERVO2_86_ORGTORQUERATIO = 27

SERVO2_86_POSERROVERFLOWLIMIT = 28

SERVO2_86_RUNCURRENT = 29
SERVO2_86_BOOSTCURRENT = 30
SERVO2_86_STOPCURRENT = 31

MAX_SERVO2_86_PARAM = 32

# ------------------------------------------------------------------
#                 POSITION TABLE Defines.
# ------------------------------------------------------------------

SERVO2_86_MAX_ITEM_COUNT = 256
