# -*- coding: utf-8 -*-
# ------------------------------------------------------------------
#                 Device Type Defines.
# ------------------------------------------------------------------

DEVTYPE_EZI_SERVO2_PLUS_R_TO = 180
DEVNAME_EZI_SERVO2_PLUS_R_TO = "Ezi-SERVO II Plus-R TO"

# ------------------------------------------------------------------
#                 Axis Status Flag Defines.
# ------------------------------------------------------------------


class EZISERVO2_TO_AXISSTATUS:
    FFLAG_ERRORALL = 0x00000001
    FFLAG_HWPOSILMT = 0x00000002
    FFLAG_HWNEGALMT = 0x00000004
    FFLAG_SWPOGILMT = 0x00000008
    FFLAG_SWNEGALMT = 0x00000010
    FFLAG_RESERVED0 = 0x00000020
    FFLAG_RESERVED1 = 0x00000040
    FFLAG_TQOFF_IN1 = 0x00000080
    FFLAG_TQOFF_IN2 = 0x00000100
    FFLAG_ERROVERSPEED = 0x00000200
    FFLAG_ERRPOSTRACKING = 0x00000400
    FFLAG_ERROVERLOAD = 0x00000800
    FFLAG_ERROVERHEAT = 0x00001000
    FFLAG_ERRBACKEMF = 0x00002000
    FFLAG_ERRMOTORPOWER = 0x00004000
    FFLAG_ERRINPOSITION = 0x00008000
    FFLAG_EMGSTOP = 0x00010000
    FFLAG_SLOWSTOP = 0x00020000
    FFLAG_ORIGINRETURNING = 0x00040000
    FFLAG_INPOSITION = 0x00080000
    FFLAG_SERVOON = 0x00100000
    FFLAG_ALARMRESET = 0x00200000
    FFLAG_PTSTOPPED = 0x00400000
    FFLAG_ORIGINSENSOR = 0x00800000
    FFLAG_ZPULSE = 0x01000000
    FFLAG_ORIGINRETOK = 0x02000000
    FFLAG_MOTIONDIR = 0x04000000
    FFLAG_MOTIONING = 0x08000000
    FFLAG_MOTIONPAUSE = 0x10000000
    FFLAG_MOTIONACCEL = 0x20000000
    FFLAG_MOTIONDECEL = 0x40000000
    FFLAG_MOTIONCONST = 0x80000000


# ------------------------------------------------------------------
#                 Input/Output Defines.
# ------------------------------------------------------------------

# Input Bit-mask list
EZISERVO2_TO_IN_BITMASK_LIMITP = 0x00000001
EZISERVO2_TO_IN_BITMASK_LIMITN = 0x00000002
EZISERVO2_TO_IN_BITMASK_ORIGIN = 0x00000004
EZISERVO2_TO_IN_BITMASK_CLEARPOSITION = 0x00000008
EZISERVO2_TO_IN_BITMASK_PTA0 = 0x00000010
EZISERVO2_TO_IN_BITMASK_PTA1 = 0x00000020
EZISERVO2_TO_IN_BITMASK_PTA2 = 0x00000040
EZISERVO2_TO_IN_BITMASK_PTA3 = 0x00000080
EZISERVO2_TO_IN_BITMASK_PTA4 = 0x00000100
EZISERVO2_TO_IN_BITMASK_PTA5 = 0x00000200
EZISERVO2_TO_IN_BITMASK_PTA6 = 0x00000400
EZISERVO2_TO_IN_BITMASK_PTA7 = 0x00000800
EZISERVO2_TO_IN_BITMASK_PTSTART = 0x00001000
EZISERVO2_TO_IN_BITMASK_STOP = 0x00002000
EZISERVO2_TO_IN_BITMASK_PJOG = 0x00004000
EZISERVO2_TO_IN_BITMASK_NJOG = 0x00008000
EZISERVO2_TO_IN_BITMASK_ALARMRESET = 0x00010000
EZISERVO2_TO_IN_BITMASK_SERVOON = 0x00020000
EZISERVO2_TO_IN_BITMASK_PAUSE = 0x00040000
EZISERVO2_TO_IN_BITMASK_ORIGINSEARCH = 0x00080000
EZISERVO2_TO_IN_BITMASK_TEACHING = 0x00100000
EZISERVO2_TO_IN_BITMASK_ESTOP = 0x00200000
EZISERVO2_TO_IN_BITMASK_JPTIN0 = 0x00400000
EZISERVO2_TO_IN_BITMASK_JPTIN1 = 0x00800000
EZISERVO2_TO_IN_BITMASK_JPTIN2 = 0x01000000
EZISERVO2_TO_IN_BITMASK_JPTSTART = 0x02000000
EZISERVO2_TO_IN_BITMASK_USERIN0 = 0x04000000
EZISERVO2_TO_IN_BITMASK_USERIN1 = 0x08000000
EZISERVO2_TO_IN_BITMASK_USERIN2 = 0x10000000
EZISERVO2_TO_IN_BITMASK_USERIN3 = 0x20000000
EZISERVO2_TO_IN_BITMASK_USERIN4 = 0x40000000
EZISERVO2_TO_IN_BITMASK_USERIN5 = 0x80000000
EZISERVO2_TO_IN_BITMASK_USERIN6 = 0x00000200
EZISERVO2_TO_IN_BITMASK_USERIN7 = 0x00000400
EZISERVO2_TO_IN_BITMASK_USERIN8 = 0x00000800

# Output Bit-mask list
EZISERVO2_TO_OUT_BITMASK_COMPAREOUT = 0x00000001
EZISERVO2_TO_OUT_BITMASK_INPOSITION = 0x00000002
EZISERVO2_TO_OUT_BITMASK_ALARM = 0x00000004
EZISERVO2_TO_OUT_BITMASK_MOVING = 0x00000008
EZISERVO2_TO_OUT_BITMASK_ACCDEC = 0x00000010
EZISERVO2_TO_OUT_BITMASK_ACK = 0x00000020
EZISERVO2_TO_OUT_BITMASK_END = 0x00000040
EZISERVO2_TO_OUT_BITMASK_PUSHDETECT = 0x00000080
EZISERVO2_TO_OUT_BITMASK_ORGSEARCHOK = 0x00000100
EZISERVO2_TO_OUT_BITMASK_SERVOREADY = 0x00000200
EZISERVO2_TO_OUT_BITMASK_MOTORPWR = 0x00000400
EZISERVO2_TO_OUT_BITMASK_BRAKE = 0x00000800
EZISERVO2_TO_OUT_BITMASK_PTOUT0 = 0x00001000
EZISERVO2_TO_OUT_BITMASK_PTOUT1 = 0x00002000
EZISERVO2_TO_OUT_BITMASK_PTOUT2 = 0x00004000
EZISERVO2_TO_OUT_BITMASK_USEROUT0 = 0x00008000
EZISERVO2_TO_OUT_BITMASK_USEROUT1 = 0x00010000
EZISERVO2_TO_OUT_BITMASK_USEROUT2 = 0x00020000
EZISERVO2_TO_OUT_BITMASK_USEROUT3 = 0x00040000
EZISERVO2_TO_OUT_BITMASK_USEROUT4 = 0x00080000
EZISERVO2_TO_OUT_BITMASK_USEROUT5 = 0x00100000
EZISERVO2_TO_OUT_BITMASK_USEROUT6 = 0x00200000
EZISERVO2_TO_OUT_BITMASK_USEROUT7 = 0x00400000
EZISERVO2_TO_OUT_BITMASK_USEROUT8 = 0x00800000


# ------------------------------------------------------------------
#                 Input/Output Assigning Defines.
# ------------------------------------------------------------------

EZISERVO2_TO_IN_PREASSIGN_LIMITP = 1
EZISERVO2_TO_IN_PREASSIGN_LIMITN = 2
EZISERVO2_TO_IN_PREASSIGN_ORIGIN = 3

EZISERVO2_TO_IN_LOGIC_CLEARPOSITION = 4
EZISERVO2_TO_IN_LOGIC_PTA0 = 5
EZISERVO2_TO_IN_LOGIC_PTA1 = 6
EZISERVO2_TO_IN_LOGIC_PTA2 = 7
EZISERVO2_TO_IN_LOGIC_PTA3 = 8
EZISERVO2_TO_IN_LOGIC_PTA4 = 9
EZISERVO2_TO_IN_LOGIC_PTA5 = 10
EZISERVO2_TO_IN_LOGIC_PTA6 = 11
EZISERVO2_TO_IN_LOGIC_PTA7 = 12
EZISERVO2_TO_IN_LOGIC_PTSTART = 13
EZISERVO2_TO_IN_LOGIC_STOP = 14
EZISERVO2_TO_IN_LOGIC_PJOG = 15
EZISERVO2_TO_IN_LOGIC_NJOG = 16
EZISERVO2_TO_IN_LOGIC_ALARMRESET = 17
EZISERVO2_TO_IN_LOGIC_SERVOON = 18
EZISERVO2_TO_IN_LOGIC_PAUSE = 19
EZISERVO2_TO_IN_LOGIC_ORIGINSEARCH = 20
EZISERVO2_TO_IN_LOGIC_TEACHING = 21
EZISERVO2_TO_IN_LOGIC_ESTOP = 22
EZISERVO2_TO_IN_LOGIC_JPTIN0 = 23
EZISERVO2_TO_IN_LOGIC_JPTIN1 = 24
EZISERVO2_TO_IN_LOGIC_JPTIN2 = 25
EZISERVO2_TO_IN_LOGIC_JPTSTART = 26
EZISERVO2_TO_IN_LOGIC_USERIN0 = 27
EZISERVO2_TO_IN_LOGIC_USERIN1 = 28
EZISERVO2_TO_IN_LOGIC_USERIN2 = 29
EZISERVO2_TO_IN_LOGIC_USERIN3 = 30
EZISERVO2_TO_IN_LOGIC_USERIN4 = 31
EZISERVO2_TO_IN_LOGIC_USERIN5 = 32

MAX_EZISERVO2_TO_IN_LOGIC = 33


EZISERVO2_TO_OUT_PREASSIGN_COMP = 1

EZISERVO2_TO_OUT_LOGIC_INPOSITION = 2
EZISERVO2_TO_OUT_LOGIC_ALARM = 3
EZISERVO2_TO_OUT_LOGIC_MOVING = 4
EZISERVO2_TO_OUT_LOGIC_ACCDEC = 5
EZISERVO2_TO_OUT_LOGIC_ACK = 6
EZISERVO2_TO_OUT_LOGIC_END = 7
EZISERVO2_TO_OUT_LOGIC_PUSHDETECT = 8
EZISERVO2_TO_OUT_LOGIC_ORGSEARCHOK = 9
EZISERVO2_TO_OUT_LOGIC_SERVOREADY = 10
EZISERVO2_TO_OUT_LOGIC_MOTORPWR = 11
EZISERVO2_TO_OUT_LOGIC_BRAKE = 12
EZISERVO2_TO_OUT_LOGIC_PTOUT0 = 13
EZISERVO2_TO_OUT_LOGIC_PTOUT1 = 14
EZISERVO2_TO_OUT_LOGIC_PTOUT2 = 15
EZISERVO2_TO_OUT_LOGIC_USEROUT0 = 16
EZISERVO2_TO_OUT_LOGIC_USEROUT1 = 17
EZISERVO2_TO_OUT_LOGIC_USEROUT2 = 18
EZISERVO2_TO_OUT_LOGIC_USEROUT3 = 19
EZISERVO2_TO_OUT_LOGIC_USEROUT4 = 20
EZISERVO2_TO_OUT_LOGIC_USEROUT5 = 21
EZISERVO2_TO_OUT_LOGIC_USEROUT6 = 22
EZISERVO2_TO_OUT_LOGIC_USEROUT7 = 23
EZISERVO2_TO_OUT_LOGIC_USEROUT8 = 24

MAX_EZISERVO2_TO_OUT_LOGIC = 25


EZISERVO2_TO_IN_PIN_CNT = 12
EZISERVO2_TO_OUT_PIN_CNT = 10

EZISERVO2_TO_IN_LOGIC_CNT = MAX_EZISERVO2_TO_IN_LOGIC - 1
EZISERVO2_TO_MAX_PREASSIGNED_IN = EZISERVO2_TO_IN_PREASSIGN_ORIGIN

EZISERVO2_TO_OUT_LOGIC_CNT = MAX_EZISERVO2_TO_OUT_LOGIC - 1
EZISERVO2_TO_MAX_PREASSIGNED_OUT = EZISERVO2_TO_OUT_PREASSIGN_COMP


# ------------------------------------------------------------------
#                 Parameters Defines.
# ------------------------------------------------------------------

EZISERVO2_TO_PULSEPERREVOLUTION = 0
EZISERVO2_TO_AXISMAXSPEED = 1
EZISERVO2_TO_AXISSTARTSPEED = 2
EZISERVO2_TO_AXISACCTIME = 3
EZISERVO2_TO_AXISDECTIME = 4

EZISERVO2_TO_SPEEDOVERRIDE = 5
EZISERVO2_TO_JOGHIGHSPEED = 6
EZISERVO2_TO_JOGLOWSPEED = 7
EZISERVO2_TO_JOGACCDECTIME = 8

EZISERVO2_TO_SWLMTPLUSVALUE = 9
EZISERVO2_TO_SWLMTMINUSVALUE = 10
EZISERVO2_TO_SOFTLMTSTOPMETHOD = 11
EZISERVO2_TO_HARDLMTSTOPMETHOD = 12
EZISERVO2_TO_LIMITSENSORLOGIC = 13

EZISERVO2_TO_ORGSPEED = 14
EZISERVO2_TO_ORGSEARCHSPEED = 15
EZISERVO2_TO_ORGACCDECTIME = 16
EZISERVO2_TO_ORGMETHOD = 17
EZISERVO2_TO_ORGDIR = 18
EZISERVO2_TO_ORGOFFSET = 19
EZISERVO2_TO_ORGPOSITIONSET = 20
EZISERVO2_TO_ORGSENSORLOGIC = 21

EZISERVO2_TO_POSITIONLOOPGAIN = 22
EZISERVO2_TO_INPOSITIONVALUE = 23
EZISERVO2_TO_POSTRACKINGLIMIT = 24
EZISERVO2_TO_MOTIONDIR = 25

EZISERVO2_TO_LIMITSENSORDIR = 26
EZISERVO2_TO_ORGTORQUERATIO = 27

EZISERVO2_TO_POSERROVERFLOWLIMIT = 28
EZISERVO2_TO_BRAKEDELAYTIME = 29

EZISERVO2_TO_RUNCURRENT = 30
EZISERVO2_TO_BOOSTCURRENT = 31
EZISERVO2_TO_STOPCURRENT = 32

MAX_EZISERVO2_TO_PARAM = 33

# ------------------------------------------------------------------
#                 POSITION TABLE Defines.
# ------------------------------------------------------------------

EZISERVO2_TO_MAX_ITEM_COUNT = 256
