# -*- coding: utf-8 -*-
# ------------------------------------------------------------------
#                 Device Type Defines.
# ------------------------------------------------------------------
DEVTYPE_EZI_SERVO_PLUS_R_ADC_ST = 3
DEVNAME_EZI_SERVO_PLUS_R_ADC_ST = "Ezi-SERVO Plus-R-ADC"

# ------------------------------------------------------------------
#                 Axis Status Flag Defines.
# ------------------------------------------------------------------

class EZISERVO_ADC_AXISSTATUS:
    FFLAG_ERRORALL = 0x00000001
    FFLAG_HWPOSILMT = 0x00000002
    FFLAG_HWNEGALMT = 0x00000004
    FFLAG_SWPOGILMT = 0x00000008
    FFLAG_SWNEGALMT = 0x00000010
    FFLAG_RESERVED0 = 0x00000020
    FFLAG_RESERVED1 = 0x00000040
    FFLAG_ERRPOSOVERFLOW = 0x00000080
    FFLAG_ERROVERCURRENT = 0x00000100
    FFLAG_ERROVERSPEED = 0x00000200
    FFLAG_ERRPOSTRACKING = 0x00000400
    FFLAG_ERROVERLOAD = 0x00000800
    FFLAG_ERROVERHEAT = 0x00001000
    FFLAG_ERRBACKEMF = 0x00002000
    FFLAG_ERRMOTORPOWER = 0x00004000
    FFLAG_ERRINPOSITION = 0x00008000
    FFLAG_EMGSTOP = 0x00010000
    FFLAG_SLOWSTOP = 0x00020000
    FFLAG_ORIGINRETURNING = 0x00040000
    FFLAG_INPOSITION = 0x00080000
    FFLAG_SERVOON = 0x00100000
    FFLAG_ALARMRESET = 0x00200000
    FFLAG_PTSTOPPED = 0x00400000
    FFLAG_ORIGINSENSOR = 0x00800000
    FFLAG_ZPULSE = 0x01000000
    FFLAG_ORIGINRETOK = 0x02000000
    FFLAG_MOTIONDIR = 0x04000000
    FFLAG_MOTIONING = 0x08000000
    FFLAG_MOTIONPAUSE = 0x10000000
    FFLAG_MOTIONACCEL = 0x20000000
    FFLAG_MOTIONDECEL = 0x40000000
    FFLAG_MOTIONCONST = 0x80000000

#------------------------------------------------------------------
#                 Input/Output Defines.
#------------------------------------------------------------------

# Input Bit-mask list
SERVO_ADC_IN_BITMASK_LIMITP = 0x00000001
SERVO_ADC_IN_BITMASK_LIMITN = 0x00000002
SERVO_ADC_IN_BITMASK_ORIGIN = 0x00000004
SERVO_ADC_IN_BITMASK_CLEARPOSITION = 0x00000008
SERVO_ADC_IN_BITMASK_PTA0 = 0x00000010
SERVO_ADC_IN_BITMASK_PTA1 = 0x00000020
SERVO_ADC_IN_BITMASK_PTA2 = 0x00000040
SERVO_ADC_IN_BITMASK_PTA3 = 0x00000080
SERVO_ADC_IN_BITMASK_PTA4 = 0x00000100
SERVO_ADC_IN_BITMASK_PTA5 = 0x00000200
SERVO_ADC_IN_BITMASK_PTA6 = 0x00000400
SERVO_ADC_IN_BITMASK_PTA7 = 0x00000800
SERVO_ADC_IN_BITMASK_PTSTART = 0x00001000
SERVO_ADC_IN_BITMASK_STOP = 0x00002000
SERVO_ADC_IN_BITMASK_PJOG = 0x00004000
SERVO_ADC_IN_BITMASK_NJOG = 0x00008000
SERVO_ADC_IN_BITMASK_ALARMRESET = 0x00010000
SERVO_ADC_IN_BITMASK_SERVOON = 0x00020000
SERVO_ADC_IN_BITMASK_PAUSE = 0x00040000
SERVO_ADC_IN_BITMASK_ORIGINSEARCH = 0x00080000
SERVO_ADC_IN_BITMASK_TEACHING = 0x00100000
SERVO_ADC_IN_BITMASK_ESTOP = 0x00200000
SERVO_ADC_IN_BITMASK_JPTIN0 = 0x00400000
SERVO_ADC_IN_BITMASK_JPTIN1 = 0x00800000
SERVO_ADC_IN_BITMASK_JPTIN2 = 0x01000000
SERVO_ADC_IN_BITMASK_JPTSTART = 0x02000000
SERVO_ADC_IN_BITMASK_USERIN0 = 0x04000000
SERVO_ADC_IN_BITMASK_USERIN1 = 0x08000000
SERVO_ADC_IN_BITMASK_USERIN2 = 0x10000000
SERVO_ADC_IN_BITMASK_USERIN3 = 0x20000000
SERVO_ADC_IN_BITMASK_USERIN4 = 0x40000000
SERVO_ADC_IN_BITMASK_USERIN5 = 0x80000000
SERVO_ADC_IN_BITMASK_USERIN6 = 0x00000200
SERVO_ADC_IN_BITMASK_USERIN7 = 0x00000400
SERVO_ADC_IN_BITMASK_USERIN8 = 0x00000800

# Output Bit-mask list
SERVO_ADC_OUT_BITMASK_COMPAREOUT = 0x00000001
SERVO_ADC_OUT_BITMASK_INPOSITION = 0x00000002
SERVO_ADC_OUT_BITMASK_ALARM = 0x00000004
SERVO_ADC_OUT_BITMASK_MOVING = 0x00000008
SERVO_ADC_OUT_BITMASK_ACCDEC = 0x00000010
SERVO_ADC_OUT_BITMASK_ACK = 0x00000020
SERVO_ADC_OUT_BITMASK_END = 0x00000040
SERVO_ADC_OUT_BITMASK_ALARMBLINK = 0x00000080
SERVO_ADC_OUT_BITMASK_ORGSEARCHOK = 0x00000100
SERVO_ADC_OUT_BITMASK_SERVOREADY = 0x00000200
# SERVO_ADC_OUT_BITMASK_RESERVED = 0x00000400
SERVO_ADC_OUT_BITMASK_BRAKE = 0x00000800
SERVO_ADC_OUT_BITMASK_PTOUT0 = 0x00001000
SERVO_ADC_OUT_BITMASK_PTOUT1 = 0x00002000
SERVO_ADC_OUT_BITMASK_PTOUT2 = 0x00004000
SERVO_ADC_OUT_BITMASK_USEROUT0 = 0x00008000
SERVO_ADC_OUT_BITMASK_USEROUT1 = 0x00010000
SERVO_ADC_OUT_BITMASK_USEROUT2 = 0x00020000
SERVO_ADC_OUT_BITMASK_USEROUT3 = 0x00040000
SERVO_ADC_OUT_BITMASK_USEROUT4 = 0x00080000
SERVO_ADC_OUT_BITMASK_USEROUT5 = 0x00100000
SERVO_ADC_OUT_BITMASK_USEROUT6 = 0x00200000
SERVO_ADC_OUT_BITMASK_USEROUT7 = 0x00400000
SERVO_ADC_OUT_BITMASK_USEROUT8 = 0x00800000


#------------------------------------------------------------------
#                 Input/Output Assigning Defines.
#------------------------------------------------------------------
SERVO_ADC_IN_PREASSIGN_LIMITP = 1
SERVO_ADC_IN_PREASSIGN_LIMITN = 2
SERVO_ADC_IN_PREASSIGN_ORIGIN = 3

SERVO_ADC_IN_LOGIC_CLEARPOSITION = 4
SERVO_ADC_IN_LOGIC_PTA0 = 5
SERVO_ADC_IN_LOGIC_PTA1 = 6
SERVO_ADC_IN_LOGIC_PTA2 = 7
SERVO_ADC_IN_LOGIC_PTA3 = 8
SERVO_ADC_IN_LOGIC_PTA4 = 9
SERVO_ADC_IN_LOGIC_PTA5 = 10
SERVO_ADC_IN_LOGIC_PTA6 = 11
SERVO_ADC_IN_LOGIC_PTA7 = 12
SERVO_ADC_IN_LOGIC_PTSTART = 13
SERVO_ADC_IN_LOGIC_STOP = 14
SERVO_ADC_IN_LOGIC_PJOG = 15
SERVO_ADC_IN_LOGIC_NJOG = 16
SERVO_ADC_IN_LOGIC_ALARMRESET = 17
SERVO_ADC_IN_LOGIC_SERVOON = 18
SERVO_ADC_IN_LOGIC_PAUSE = 19
SERVO_ADC_IN_LOGIC_ORIGINSEARCH = 20
SERVO_ADC_IN_LOGIC_TEACHING = 21
SERVO_ADC_IN_LOGIC_ESTOP = 22
SERVO_ADC_IN_LOGIC_JPTIN0 = 23
SERVO_ADC_IN_LOGIC_JPTIN1 = 24
SERVO_ADC_IN_LOGIC_JPTIN2 = 25
SERVO_ADC_IN_LOGIC_JPTSTART = 26
SERVO_ADC_IN_LOGIC_USERIN0 = 27
SERVO_ADC_IN_LOGIC_USERIN1 = 28
SERVO_ADC_IN_LOGIC_USERIN2 = 29
SERVO_ADC_IN_LOGIC_USERIN3 = 30
SERVO_ADC_IN_LOGIC_USERIN4 = 31
SERVO_ADC_IN_LOGIC_USERIN5 = 32

MAX_SERVO_ADC_IN_LOGIC = 33


SERVO_ADC_OUT_PREASSIGN_COMP = 1

SERVO_ADC_OUT_LOGIC_INPOSITION = 2
SERVO_ADC_OUT_LOGIC_ALARM = 3
SERVO_ADC_OUT_LOGIC_MOVING = 4
SERVO_ADC_OUT_LOGIC_ACCDEC = 5
SERVO_ADC_OUT_LOGIC_ACK = 6
SERVO_ADC_OUT_LOGIC_END = 7
SERVO_ADC_OUT_LOGIC_ALARMBLINK = 8
SERVO_ADC_OUT_LOGIC_ORGSEARCHOK = 9
SERVO_ADC_OUT_LOGIC_SERVOREADY = 10
SERVO_ADC_OUT_LOGIC_RESERVED0 = 11
SERVO_ADC_OUT_LOGIC_BRAKE = 12
SERVO_ADC_OUT_LOGIC_PTOUT0 = 13
SERVO_ADC_OUT_LOGIC_PTOUT1 = 14
SERVO_ADC_OUT_LOGIC_PTOUT2 = 15
SERVO_ADC_OUT_LOGIC_USEROUT0 = 16
SERVO_ADC_OUT_LOGIC_USEROUT1 = 17
SERVO_ADC_OUT_LOGIC_USEROUT2 = 18
SERVO_ADC_OUT_LOGIC_USEROUT3 = 19
SERVO_ADC_OUT_LOGIC_USEROUT4 = 20
SERVO_ADC_OUT_LOGIC_USEROUT5 = 21
SERVO_ADC_OUT_LOGIC_USEROUT6 = 22
SERVO_ADC_OUT_LOGIC_USEROUT7 = 23
SERVO_ADC_OUT_LOGIC_USEROUT8 = 24

MAX_SERVO_ADC_OUT_LOGIC = 25

SERVO_ADC_IN_PIN_CNT	= 12
SERVO_ADC_OUT_PIN_CNT	= 10

SERVO_ADC_IN_LOGIC_CNT			= (MAX_SERVO_ADC_IN_LOGIC - 1)
SERVO_ADC_MAX_PREASSIGNED_IN	= (SERVO_ADC_IN_PREASSIGN_ORIGIN)

SERVO_ADC_OUT_LOGIC_CNT			= (MAX_SERVO_ADC_OUT_LOGIC - 1)
SERVO_ADC_MAX_PREASSIGNED_OUT	= (SERVO_ADC_OUT_PREASSIGN_COMP)

#------------------------------------------------------------------
#                 Parameters Defines.
#------------------------------------------------------------------

SERVO_ADC_PULSEPERREVOLUTION = 0
SERVO_ADC_AXISMAXSPEED = 1
SERVO_ADC_AXISSTARTSPEED = 2
SERVO_ADC_AXISACCTIME = 3
SERVO_ADC_AXISDECTIME = 4

SERVO_ADC_SPEEDOVERRIDE = 5
SERVO_ADC_JOGHIGHSPEED = 6
SERVO_ADC_JOGLOWSPEED = 7
SERVO_ADC_JOGACCDECTIME = 8

SERVO_ADC_SERVOALARMLOGIC = 9
SERVO_ADC_SERVOONLOGIC = 10
SERVO_ADC_SERVORESETLOGIC = 11

SERVO_ADC_SWLMTPLUSVALUE = 12
SERVO_ADC_SWLMTMINUSVALUE = 13
SERVO_ADC_SOFTLMTSTOPMETHOD = 14
SERVO_ADC_HARDLMTSTOPMETHOD = 15
SERVO_ADC_LIMITSENSORLOGIC = 16

SERVO_ADC_ORGSPEED = 17
SERVO_ADC_ORGSEARCHSPEED = 18
SERVO_ADC_ORGACCDECTIME = 19
SERVO_ADC_ORGMETHOD = 20
SERVO_ADC_ORGDIR = 21
SERVO_ADC_ORGOFFSET = 22
SERVO_ADC_ORGPOSITIONSET = 23
SERVO_ADC_ORGSENSORLOGIC = 24

SERVO_ADC_POSITIONLOOPGAIN = 25
SERVO_ADC_INPOSITIONVALUE = 26
SERVO_ADC_POSTRACKINGLIMIT = 27
SERVO_ADC_MOTIONDIR = 28

SERVO_ADC_LIMITSENSORDIR = 29
SERVO_ADC_ORGTORQUERATIO = 30

SERVO_ADC_POSERROVERFLOWLIMIT = 31

SERVO_ADC_FUTURE_USE_A = 32
SERVO_ADC_FUTURE_USE_B = 33
SERVO_ADC_FUTURE_USE_C = 34

SERVO_ADC_BALL_SCREW_PITCH = 35

SERVO_ADC_GAPCOMP_MINRANGE = 36
SERVO_ADC_GAPCOMP_MAXRANGE = 37
SERVO_ADC_GAPCOMP_DIFFRANGE = 38
SERVO_ADC_GAPCOMP_DELAY = 39
SERVO_ADC_LASERFILTER_LENGTH = 40
SERVO_ADC_GAPCOMP_OUTPUTLIMIT = 41
SERVO_ADC_ADCDISTANCE_RATIO = 42

SERVO_ADC_LC_OR_SEAL = 43

MAX_SERVO_ADC_PARAM = 44

#------------------------------------------------------------------
#                 POSITION TABLE Defines.
#------------------------------------------------------------------

SERVO_ADC_MAX_ITEM_COUNT = 512