# -*- coding: utf-8 -*-
#------------------------------------------------------------------
#                 Device Type Defines.
#------------------------------------------------------------------

DEVTYPE_EZI_STEP_PLUS_R_ST = 20
DEVNAME_EZI_STEP_PLUS_R_ST = "Ezi-STEP Plus-R-ST"

#------------------------------------------------------------------
#                 Axis Status Flag Defines.
#------------------------------------------------------------------

class EZISTEP_AXISSTATUS:
    FFLAG_ERRORALL          = 0x00000001
    FFLAG_HWPOSILMT         = 0x00000002
    FFLAG_HWNEGALMT         = 0x00000004
    FFLAG_SWPOGILMT         = 0x00000008
    FFLAG_SWNEGALMT         = 0x00000010
    FFLAG_RESERVED0         = 0x00000020
    FFLAG_RESERVED1         = 0x00000040
    FFLAG_ERRSTEPALARM      = 0x00000080
    FFLAG_ERROVERCURRENT    = 0x00000100
    FFLAG_ERROVERSPEED      = 0x00000200
    FFLAG_ERRSTEPOUT        = 0x00000400
    FFLAG_RESERVED2         = 0x00000800
    FFLAG_ERROVERHEAT       = 0x00001000
    FFLAG_ERRBACKEMF        = 0x00002000
    FFLAG_ERRMOTORPOWER     = 0x00004000
    FFLAG_ERRLOWPOWER       = 0x00008000
    FFLAG_EMGSTOP           = 0x00010000
    FFLAG_SLOWSTOP          = 0x00020000
    FFLAG_ORIGINRETURNING   = 0x00040000
    FFLAG_RESERVED3         = 0x00080000
    FFLAG_RESERVED4         = 0x00100000
    FFLAG_ALARMRESET        = 0x00200000
    FFLAG_PTSTOPPED         = 0x00400000
    FFLAG_ORIGINSENSOR      = 0x00800000
    FFLAG_ZPULSE            = 0x01000000
    FFLAG_ORIGINRETOK       = 0x02000000
    FFLAG_MOTIONDIR         = 0x04000000
    FFLAG_MOTIONING         = 0x08000000
    FFLAG_MOTIONPAUSE       = 0x10000000
    FFLAG_MOTIONACCEL       = 0x20000000
    FFLAG_MOTIONDECEL       = 0x40000000
    FFLAG_MOTIONCONST       = 0x80000000

#------------------------------------------------------------------
#                 Input/Output Defines.
#------------------------------------------------------------------

# Input Bit-mask list
STEP_IN_BITMASK_LIMITP          = 0x00000001
STEP_IN_BITMASK_LIMITN          = 0x00000002
STEP_IN_BITMASK_ORIGIN          = 0x00000004
STEP_IN_BITMASK_CLEARPOSITION   = 0x00000008
STEP_IN_BITMASK_PTA0            = 0x00000010
STEP_IN_BITMASK_PTA1            = 0x00000020
STEP_IN_BITMASK_PTA2            = 0x00000040
STEP_IN_BITMASK_PTA3            = 0x00000080
STEP_IN_BITMASK_PTA4            = 0x00000100
STEP_IN_BITMASK_PTA5            = 0x00000200
STEP_IN_BITMASK_PTA6            = 0x00000400
STEP_IN_BITMASK_PTA7            = 0x00000800
STEP_IN_BITMASK_PTSTART         = 0x00001000
STEP_IN_BITMASK_STOP            = 0x00002000
STEP_IN_BITMASK_PJOG            = 0x00004000
STEP_IN_BITMASK_NJOG            = 0x00008000
STEP_IN_BITMASK_ALARMRESET      = 0x00010000
# STEP_IN_BITMASK_RESERVED      = 0x00020000
STEP_IN_BITMASK_PAUSE           = 0x00040000
STEP_IN_BITMASK_ORIGINSEARCH    = 0x00080000
STEP_IN_BITMASK_TEACHING        = 0x00100000
STEP_IN_BITMASK_ESTOP           = 0x00200000
STEP_IN_BITMASK_JPTIN0          = 0x00400000
STEP_IN_BITMASK_JPTIN1          = 0x00800000
STEP_IN_BITMASK_JPTIN2          = 0x01000000
STEP_IN_BITMASK_JPTSTART        = 0x02000000
STEP_IN_BITMASK_USERIN0         = 0x04000000
STEP_IN_BITMASK_USERIN1         = 0x08000000
STEP_IN_BITMASK_USERIN2         = 0x10000000
STEP_IN_BITMASK_USERIN3         = 0x20000000
STEP_IN_BITMASK_USERIN4         = 0x40000000
STEP_IN_BITMASK_USERIN5         = 0x80000000
STEP_IN_BITMASK_USERIN6         = 0x00000200
STEP_IN_BITMASK_USERIN7         = 0x00000400
STEP_IN_BITMASK_USERIN8         = 0x00000800

# Output Bit-mask list
STEP_OUT_BITMASK_COMPAREOUT     = 0x00000001
# STEP_OUT_BITMASK_RESERVED     = 0x00000002
STEP_OUT_BITMASK_ALARM          = 0x00000004
STEP_OUT_BITMASK_RUNSTOP        = 0x00000008
STEP_OUT_BITMASK_ACCDEC         = 0x00000010
STEP_OUT_BITMASK_ACK            = 0x00000020
STEP_OUT_BITMASK_END            = 0x00000040
STEP_OUT_BITMASK_ALARMBLINK     = 0x00000080
STEP_OUT_BITMASK_ORGSEARCHOK    = 0x00000100
# STEP_OUT_BITMASK_RESERVED     = 0x00000200
# STEP_OUT_BITMASK_RESERVED     = 0x00000400
STEP_OUT_BITMASK_BRAKE          = 0x00000800
STEP_OUT_BITMASK_PTOUT0         = 0x00001000
STEP_OUT_BITMASK_PTOUT1         = 0x00002000
STEP_OUT_BITMASK_PTOUT2         = 0x00004000
STEP_OUT_BITMASK_USEROUT0       = 0x00008000
STEP_OUT_BITMASK_USEROUT1       = 0x00010000
STEP_OUT_BITMASK_USEROUT2       = 0x00020000
STEP_OUT_BITMASK_USEROUT3       = 0x00040000
STEP_OUT_BITMASK_USEROUT4       = 0x00080000
STEP_OUT_BITMASK_USEROUT5       = 0x00100000
STEP_OUT_BITMASK_USEROUT6       = 0x00200000
STEP_OUT_BITMASK_USEROUT7       = 0x00400000
STEP_OUT_BITMASK_USEROUT8       = 0x00800000

#------------------------------------------------------------------
#                 Input/Output Assigning Defines.
#------------------------------------------------------------------

STEP_IN_PREASSIGN_LIMITP = 1
STEP_IN_PREASSIGN_LIMITN = 2
STEP_IN_PREASSIGN_ORIGIN = 3

STEP_IN_LOGIC_CLEARPOSITION = 4
STEP_IN_LOGIC_PTA0 = 5
STEP_IN_LOGIC_PTA1 = 6
STEP_IN_LOGIC_PTA2 = 7
STEP_IN_LOGIC_PTA3 = 8
STEP_IN_LOGIC_PTA4 = 9
STEP_IN_LOGIC_PTA5 = 10
STEP_IN_LOGIC_PTA6 = 11
STEP_IN_LOGIC_PTA7 = 12
STEP_IN_LOGIC_PTSTART = 13
STEP_IN_LOGIC_STOP = 14
STEP_IN_LOGIC_PJOG = 15
STEP_IN_LOGIC_NJOG = 16
STEP_IN_LOGIC_ALARMRESET = 17
STEP_IN_LOGIC_RESERVED0 = 18
STEP_IN_LOGIC_PAUSE = 19
STEP_IN_LOGIC_ORIGINSEARCH = 20
STEP_IN_LOGIC_TEACHING = 21
STEP_IN_LOGIC_ESTOP = 22
STEP_IN_LOGIC_JPTIN0 = 23
STEP_IN_LOGIC_JPTIN1 = 24
STEP_IN_LOGIC_JPTIN2 = 25
STEP_IN_LOGIC_JPTSTART = 26
STEP_IN_LOGIC_USERIN0 = 27
STEP_IN_LOGIC_USERIN1 = 28
STEP_IN_LOGIC_USERIN2 = 29
STEP_IN_LOGIC_USERIN3 = 30
STEP_IN_LOGIC_USERIN4 = 31
STEP_IN_LOGIC_USERIN5 = 32

MAX_STEP_IN_LOGIC = 33


STEP_OUT_PREASSIGN_COMP = 1

STEP_OUT_LOGIC_RESERVED0 = 2
STEP_OUT_LOGIC_ALARM = 3
STEP_OUT_LOGIC_RUNSTOP = 4
STEP_OUT_LOGIC_ACCDEC = 5
STEP_OUT_LOGIC_ACK = 6
STEP_OUT_LOGIC_END = 7
STEP_OUT_LOGIC_ALARMBLINK = 8
STEP_OUT_LOGIC_ORGSEARCHOK = 9
STEP_OUT_LOGIC_RESERVED1 = 10
STEP_OUT_LOGIC_RESERVED2 = 11
STEP_OUT_LOGIC_BRAKE = 12
STEP_OUT_LOGIC_PTOUT0 = 13
STEP_OUT_LOGIC_PTOUT1 = 14
STEP_OUT_LOGIC_PTOUT2 = 15
STEP_OUT_LOGIC_USEROUT0 = 16
STEP_OUT_LOGIC_USEROUT1 = 17
STEP_OUT_LOGIC_USEROUT2 = 18
STEP_OUT_LOGIC_USEROUT3 = 19
STEP_OUT_LOGIC_USEROUT4 = 20
STEP_OUT_LOGIC_USEROUT5 = 21
STEP_OUT_LOGIC_USEROUT6 = 22
STEP_OUT_LOGIC_USEROUT7 = 23
STEP_OUT_LOGIC_USEROUT8 = 24

MAX_STEP_OUT_LOGIC = 25


STEP_IN_PIN_CNT	= 12
STEP_OUT_PIN_CNT	= 10

STEP_IN_LOGIC_CNT			= (MAX_STEP_IN_LOGIC - 1)
STEP_MAX_PREASSIGNED_IN		= (STEP_IN_PREASSIGN_ORIGIN)

STEP_OUT_LOGIC_CNT			= (MAX_STEP_OUT_LOGIC - 1)
STEP_MAX_PREASSIGNED_OUT	= (STEP_OUT_PREASSIGN_COMP)

#------------------------------------------------------------------
#                 Parameters Defines.
#------------------------------------------------------------------

STEP_PULSEPERREVOLUTION = 0
STEP_AXISMAXSPEED = 1
STEP_AXISSTARTSPEED = 2
STEP_AXISACCTIME = 3
STEP_AXISDECTIME = 4

STEP_SPEEDOVERRIDE = 5
STEP_JOGHIGHSPEED = 6
STEP_JOGLOWSPEED = 7
STEP_JOGACCDECTIME = 8

STEP_ALARMLOGIC = 9
STEP_RUNSTOPSIGNALLOGIC = 10		#SERVO_SERVOONLOGIC
STEP_RESETLOGIC = 11

STEP_SWLMTPLUSVALUE = 12
STEP_SWLMTMINUSVALUE = 13
STEP_SOFTLMTSTOPMETHOD = 14
STEP_HARDLMTSTOPMETHOD = 15
STEP_LIMITSENSORLOGIC = 16

STEP_ORGSPEED = 17
STEP_ORGSEARCHSPEED = 18
STEP_ORGACCDECTIME = 19
STEP_ORGMETHOD = 20
STEP_ORGDIR = 21
STEP_ORGOFFSET = 22
STEP_ORGPOSITIONSET = 23
STEP_ORGSENSORLOGIC = 24

STEP_STOPCURRENT = 25
STEP_MOTIONDIR = 26

STEP_LIMITSENSORDIR = 27
STEP_ENCODERMULTIVALUE = 28

STEP_ENCODERDIR = 29
STEP_POSVALUECOUNTINGMETHOD = 30

MAX_STEP_PARAM = 31

#------------------------------------------------------------------
#                 POSITION TABLE Defines.
#------------------------------------------------------------------

STEP_MAX_ITEM_COUNT = 256
